/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { PolarBase } from "./PolarBase";
import { PathRenderer } from "./PathRenderer";
import { DefaultFlattener } from "./DefaultFlattener";
import { PolarBaseView } from "./PolarBaseView";
import { Number_$type, Point_$type, markType } from "igniteui-angular-core";
import { PolarLinePlanner } from "./PolarLinePlanner";
import { List$1 } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
var PolarLineSeriesBase = /** @class */ (function (_super) {
    tslib_1.__extends(PolarLineSeriesBase, _super);
    function PolarLineSeriesBase() {
        var _this = _super.call(this) || this;
        _this.sw = null;
        _this.sy = null;
        _this.sx = null;
        _this.sw = new PathRenderer(1, new DefaultFlattener());
        _this.sy = new PathRenderer(0);
        return _this;
    }
    PolarLineSeriesBase.prototype.get_qv = function () {
        return true;
    };
    PolarLineSeriesBase.prototype.bp = function () {
        return new PolarLineSeriesBaseView(this);
    };
    PolarLineSeriesBase.prototype.kk = function (a) {
        _super.prototype.kk.call(this, a);
        this.sz = a;
    };
    PolarLineSeriesBase.prototype.s0 = function () {
        return 1;
    };
    PolarLineSeriesBase.prototype.get_s3 = function () {
        return false;
    };
    Object.defineProperty(PolarLineSeriesBase.prototype, "s3", {
        get: function () {
            return this.get_s3();
        },
        enumerable: true,
        configurable: true
    });
    PolarLineSeriesBase.prototype.get_s5 = function () {
        return false;
    };
    Object.defineProperty(PolarLineSeriesBase.prototype, "s5", {
        get: function () {
            return this.get_s5();
        },
        enumerable: true,
        configurable: true
    });
    PolarLineSeriesBase.prototype.r0 = function (a, b) {
        var _this = this;
        _super.prototype.r0.call(this, a, b);
        a.m.clear();
        var c = b.bv;
        var d = b.bu;
        var e = this.qk != null ? this.qk.count : 0;
        var f = this.ql != null ? this.ql.count : 0;
        var g = Math.min(e, f);
        var h = ((function () {
            var $ret = new PolarLinePlanner();
            $ret.m = function (i) { return _this.p3.a.getScaledAngle1(_this.qk.item(i), _this.p3.e, _this.p3.d); };
            $ret.q = g;
            $ret.n = function (i) { return _this.p1.lz(_this.ql.item(i), _this.p3.g, _this.p3.f, _this.p3.i, _this.p3.h); };
            $ret.l = _this.fq;
            $ret.f = _this.q0;
            $ret.b = _this.s0();
            $ret.o = function (i) { return _this.s6(a, i); };
            $ret.p = function (i) { return _this.s7(a, i); };
            $ret.ab = d;
            $ret.ac = c;
            $ret.d = _this.s5;
            $ret.c = _this.s3;
            return $ret;
        })());
        var i = new List$1(Number_$type, 0);
        for (var j = 0; j < g; j++) {
            if (this.s4(j)) {
                i.add(j);
            }
        }
        if (this.s5 && i.count > 0) {
            i.add(i._inner[0]);
        }
        h.x(a.m, i);
    };
    PolarLineSeriesBase.prototype.s6 = function (a, b) {
        return a.w._inner[b].x;
    };
    PolarLineSeriesBase.prototype.s7 = function (a, b) {
        return a.w._inner[b].y;
    };
    PolarLineSeriesBase.prototype.s2 = function () {
        return !this.s1();
    };
    PolarLineSeriesBase.prototype.s1 = function () {
        var a = this.b6.os;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    PolarLineSeriesBase.prototype.s4 = function (a) {
        return (this.qk.item(a) >= this.p3.a.kd && this.qk.item(a) <= this.p3.a.kc && this.ql.item(a) >= this.p3.b.kd && this.ql.item(a) <= this.p3.b.kc) || (isNaN_(this.qk.item(a)) || isNaN_(this.ql.item(a)));
    };
    PolarLineSeriesBase.prototype.jl = function (a, b) {
        _super.prototype.jl.call(this, a, b);
        this.s8(b);
    };
    PolarLineSeriesBase.prototype.r4 = function (a, b) {
        _super.prototype.r4.call(this, a, b);
        if (this.q0) {
            this.sx = this.sw;
        }
        else {
            this.sx = this.sy;
        }
        this.sx.b = this.s0();
        this.s8(b);
        this.s9(a, b);
    };
    PolarLineSeriesBase.$t = markType(PolarLineSeriesBase, 'PolarLineSeriesBase', PolarBase.$);
    return PolarLineSeriesBase;
}(PolarBase));
export { PolarLineSeriesBase };
/**
 * @hidden
 */
var PolarLineSeriesBaseView = /** @class */ (function (_super) {
    tslib_1.__extends(PolarLineSeriesBaseView, _super);
    function PolarLineSeriesBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.c3 = null;
        _this.c3 = a;
        return _this;
    }
    PolarLineSeriesBaseView.prototype.af = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.ni = a;
        this.e.fs = 3;
        this.e.ft = 1;
        this.e.fu = 4;
        this.e.ea = false;
    };
    PolarLineSeriesBaseView.$t = markType(PolarLineSeriesBaseView, 'PolarLineSeriesBaseView', PolarBaseView.$);
    return PolarLineSeriesBaseView;
}(PolarBaseView));
export { PolarLineSeriesBaseView };
//# sourceMappingURL=PolarLineSeriesBase_combined.js.map